﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;

using ProgramowanieObiektowe2;

namespace TestyJednostkoweUłamka
{
    [TestClass]
    public class UnitTest1
    {
        [TestMethod]
        public void TestObliczaniaNWD()
        {
            uint a = 12, b = 16;
            uint nwd = Ułamek.ObliczNWD(a, b);

            Assert.AreEqual(4U, nwd);
        }

        [TestMethod]
        public void TestObliczaniaNWD2()
        {
            uint a = 16, b = 12;
            uint nwd = Ułamek.ObliczNWD(a, b);

            Assert.AreEqual(4U, nwd);
        }

        [TestMethod]
        public void TestObliczaniaNWD3()
        {
            uint a = 1, b = 3;
            for(uint i = 2; i < 100; i++)
            {
                uint nwd = Ułamek.ObliczNWD(i*a, i*b);
                Assert.AreEqual(i, nwd);
            }
        }

        [TestMethod]
        public void TestKonstruktoraIMianownik()
        {
            int a = 1, b = 2;
            Ułamek u = new Ułamek(a, b);
            Assert.AreEqual(2, u.Mianownik);
        }

        [TestMethod]
        public void TestKonstruktora()
        {
            int a = 1, b = 2;
            Ułamek u = new Ułamek(a, b);

            Assert.AreEqual(a, u.Licznik);

            PrivateObject po = new PrivateObject(u);
            int u_mianownik = (int)po.GetField("mianownik");
            Assert.AreEqual(b, u_mianownik);
        }

        [TestMethod]
        public void TestWłasnościMianownik()
        {
            int a = 1, b = 2;

            Ułamek u = new Ułamek();
            u.Licznik = a;

            PrivateObject po = new PrivateObject(u);
            po.SetField("mianownik", b);

            Assert.AreEqual(a, u.Licznik);
            Assert.AreEqual(b, u.Mianownik);            
        }

        [TestMethod]
        [ExpectedException(typeof(Exception))]
        public void TestBłęduKonstruktora()
        {
            Ułamek u = new Ułamek(1, 0);
        }
    }
}
